Insight engine (Deprecated)
Insight engine (Deprecated)
|
|
Headless v1 has been deprecated. We recommend using the latest version of the Coveo Headless library. |
Initialize
buildInsightEngine
Creates an insight engine instance.
Parameters
-
options:
InsightEngineOptionsThe insight engine options.
Returns InsightEngine
InsightEngineOptions
The insight engine options.
Properties
-
configuration:
InsightEngineConfigurationThe insight engine configuration options.
-
loggerOptions?:
LoggerOptionsThe logger options.
-
middlewares?:
Middleware<{}, State>[]List of additional middlewares. A middleware is a higher-order function that composes a dispatch function to return a new dispatch function. It is useful for logging actions, performing side effects like routing, or turning an asynchronous API call into a series of synchronous actions.
-
preloadedState?:
StateThe initial headless state. You may optionally specify it to hydrate the state from the server in universal apps, or to restore a previously serialized user session.
InsightEngineConfiguration
The insight engine configuration options.
Properties
-
insightId:
stringSpecifies the unique identifier of the target insight configuration.
-
accessToken:
stringThe access token to use to authenticate requests against the Coveo endpoints. Typically, this will be an API key or search token that grants the privileges to execute queries and push usage analytics data in the target Coveo organization.
-
organizationId:
stringThe unique identifier of the target Coveo organization (for example,
mycoveocloudorganizationg8tp8wu3) -
analytics?:
AnalyticsConfigurationAllows configuring options related to analytics.
-
name?:
stringThe Engine name (for example, myEngine). Specifying your Engine name will help in debugging when using an application with multiple Redux stores.
Default: 'coveo-headless'
-
platformUrl?:
stringThe Platform URL to use. (for example, https://platform.cloud.coveo.com) The platformUrl() helper method can be useful to know what url is available.
-
preprocessRequest?:
PreprocessRequestAllows for augmenting a Platform request before it is sent.
-
renewAccessToken?:
() => Promise<string>A function that fetches a new access token. The function must return a Promise that resolves to a string (the new access token).
LoggerOptions
The logger options.
Properties
-
browserPostLogHook?:
(level: LogLevel, logEvent: LogEvent) => voidFunction which will be called after writing the log message in the browser.
-
level?:
LevelWithSilentBy default, is set to
warn. -
logFormatter?:
(object: object) => objectChanges the shape of the log object. This function will be called every time one of the log methods (such as
.info) is called. All arguments passed to the log method, except the message, will be pass to this function. By default it does not change the shape of the log object.
Middleware<{}, State>[]
List of additional middlewares. A middleware is a higher-order function that composes a dispatch function to return a new dispatch function. It is useful for logging actions, performing side effects like routing, or turning an asynchronous API call into a series of synchronous actions.
Properties
-
(call):
(api: MiddlewareAPI<D, S>): ( next: Dispatch<AnyAction> ) => (action: any) => any
AnalyticsConfiguration
Allows configuring options related to analytics.
Properties
-
analyticsClientMiddleware?:
AnalyticsClientSendEventHookanalyticsClientMiddleware allows to hook into an analytics event payload before it is sent to the Coveo platform.
-
anonymous?:
booleanWhether analytics events should be logged anonymously. If set to true, the Usage Analytics Write API will not extract the name and userDisplayName, if present, from the search token
-
deviceId?:
stringThe name of the device that the end user is using. It should be explicitly configured in the context of a native mobile app.
-
documentLocation?:
stringSpecifies the URL of the current page or component.
-
enabled?:
booleanSpecifies if usage analytics tracking should be enabled.
By default, all analytics events will be logged.
-
originContext?:
stringSets the Origin Context dimension on the analytic events.
You can use this dimension to specify the context of your application. The possible values are "Search", "InternalSearch", and "CommunitySearch."
The default value is
Search. -
originLevel2?:
stringOrigin level 2 is a usage analytics event metadata whose value should typically be the name/identifier of the tab from which the usage analytics event originates.
When logging a Search usage analytics event, originLevel2 should always be set to the same value as the corresponding tab (parameter) Search API query parameter so Coveo Machine Learning models function properly, and usage analytics reports and dashboards are coherent.
This value is optional, and will automatically try to resolve itself from the tab search parameter.
-
originLevel3?:
stringOrigin level 3 is a usage analytics event metadata whose value should typically be the URL of the page that linked to the search interface that’s making the request.
When logging a Search usage analytics event, originLevel3 should always be set to the same value as the corresponding referrer Search API query parameter so usage analytics reports and dashboards are coherent.
This value is optional, and will automatically try to resolve itself from the referrer search parameter.
-
runtimeEnvironment?:
IRuntimeEnvironmentOptional analytics runtime environment, this is needed for analytics to work correctly if you’re running outside of a browser. See https://github.com/coveo/coveo.analytics.js for more info.
-
userDisplayName?:
stringSpecifies the user display name for the usage analytics logs.
Related types
Unsubscribe
Call signatures
-
(): void
Methods
executeFirstSearch
Executes the first search.
Parameters
-
analyticsEvent:
SearchActionThe analytics event to log in association with the first search. If unspecified,
logInsightInterfaceLoadwill be used.
addReducers
Adds the specified reducers to the store.
Parameters
-
reducers:
ReducersMapObjectAn object containing the reducers to attach to the engine.
disableAnalytics
Disable analytics tracking
enableAnalytics
Enable analytics tracking
subscribe
Adds a change listener. It will be called any time an action is dispatched, and some part of the state tree may potentially have changed. You may then access the new state.
Parameters
-
listener:
() => voidA callback to be invoked on every dispatch.
Returns Unsubscribe: A function to remove this change listener.